// -*- C++ -*-
/*!
 * @file  VS_RTC_SAMPLE.cpp
 * @brief BeautoRTC sample
 * @date $Date$
 *
 * $Id$
 */

#include "VS_RTC_SAMPLE.h"

// Module specification
// <rtc-template block="module_spec">
static const char* vs_rtc_sample_spec[] =
  {
    "implementation_id", "VS_RTC_SAMPLE",
    "type_name",         "VS_RTC_SAMPLE",
    "description",       "BeautoRTC sample",
    "version",           "0.1",
    "vendor",            "Vstone",
    "category",          "Test",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "0",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
VS_RTC_SAMPLE::VS_RTC_SAMPLE(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
VS_RTC_SAMPLE::~VS_RTC_SAMPLE()
{
}



RTC::ReturnCode_t VS_RTC_SAMPLE::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t VS_RTC_SAMPLE::onExecute(RTC::UniqueId ec_id)
{
  //CPU{[hƐڑ
  if(CWRC_Connect()){
    //E̐ԊOZT͂ǂݍ
    //AhX0x1a=AiOCh14byteǂݍ
    CWRC_ReadMemMap(0x1a,4);

    //ǂݍݏs
    CWRC_ReadExecute();

    //擾lʂɕ\
    std::cout << "Get parameters from CPU is succeed." << std::endl;
    std::cout << "ch1." << wrc_mem_uw(0x1a) << std::endl;
    std::cout << "ch2." << wrc_mem_uw(0x1c) << std::endl;

    //CPU{[hƂ̐ڑؒf
    CWRC_Disconnect();
  }
  else std::cout << "Couldn't connect CPU." << std::endl;
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t VS_RTC_SAMPLE::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void VS_RTC_SAMPLEInit(RTC::Manager* manager)
  {
    coil::Properties profile(vs_rtc_sample_spec);
    manager->registerFactory(profile,
                             RTC::Create<VS_RTC_SAMPLE>,
                             RTC::Delete<VS_RTC_SAMPLE>);
  }
  
};


